﻿# -*- coding: UTF-8 -*-
import os
import re
import json
import traceback


def get_tags():
    return ['2', '2.3', '2.3.2']


def run_task(runcontext):

    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)
    module = runcontext.get_module_file("shell.py")
    curtemplate = runcontext.get_template()

    apache_scripfiles = runcontext.get_extra_var('APACHE_SCRIPTALIAS')
    apache_home = runcontext.get_extra_var('APACHE_HOME')
    apache_manual = os.path.join(apache_home, "manual")
    apache_docroot = runcontext.get_extra_var('APACHE_DOCUMENTROOT')
    apache_manual = runcontext.replace_inject_characters(apache_manual)
    apache_docroot = runcontext.replace_inject_characters(apache_docroot)
    runcontext.log_debug("apache_scripfiles：%s" % str(apache_scripfiles))
    runcontext.log_debug("apache_home：%s" % str(apache_home))
    runcontext.log_debug("apache_manual：%s" % str(apache_manual))
    runcontext.log_debug("apache_docroot：%s" % str(apache_docroot))
    scripts = []

    try:

        for sfile in apache_scripfiles:
            if '/cgi-bin/' in sfile:
                scripts.append(runcontext.replace_inject_characters(''.join(sfile[1:])))

        runcontext.log_debug("scripts,apache_manual,apache_docroot %s ,%s, %s" % (scripts, apache_manual, apache_docroot))
        ret_code = 0
        ret_msg = ''
        errMsg = []
        tmp_vars = {}
        tmp_vars['policyresult'] = 'failed'
        tmp_vars['checkresult1'] = 'failed'
        tmp_vars['checkvalue1'] = ''
        tmp_vars['scancommand1'] = "ls %s 2>/dev/null" % apache_manual
        tmp_vars['scancommand2'] = "ls %s 2>/dev/null" % apache_docroot

        runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
        arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
        runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
        runcontext.sleep()
        resultjson1 = json.loads(astdout1)
        astdout1 = resultjson1["stdout"]
        match1_found = re.match("^$", astdout1)

        if match1_found == None:
            errMsg.append("%s directory file list:\n%s" % (apache_manual, astdout1))

        runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand2"])
        arc2, astdout2, astderr2 = runcontext.invoke_module(module, ansible_params)
        runcontext.log_debug_invoke_result(arc2, astdout2, astderr2)
        runcontext.sleep()
        resultjson2 = json.loads(astdout2)
        astdout2 = resultjson2["stdout"]
        match2_found = re.match("^$", astdout2)

        if match2_found == None:
            errMsg.append("%s directory file list:\n%s" % (apache_docroot, astdout2))

        for sf in scripts:
            tmp_vars['scancommand3'] = "ls %s 2>/dev/null" % sf
            runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand3"])
            arc3, astdout3, astderr3 = runcontext.invoke_module(module, ansible_params)
            runcontext.log_debug_invoke_result(arc3, astdout3, astderr3)
            runcontext.sleep()
            resultjson3 = json.loads(astdout3)
            astdout3 = resultjson3["stdout"]
            runcontext.log_debug("astdout3:%s." % astdout3)
            match3_found = re.match("^$", astdout3)
            if match3_found == None:
                errMsg.append("%s directory file list:\n%s" % (sf, astdout3))
                break

        if len(errMsg) == 0:
            tmp_vars["policyresult"] = "pass"
            tmp_vars["checkresult1"] = "pass"
            tmp_vars["checkvalue1"] = ''
        else:
            ret_code = -1
            tmp_vars["checkvalue1"] = '\n'.join(errMsg)

        rc, out = curtemplate.render(runcontext.get_template_file('r_2_3_2.j2'), **tmp_vars)

        if rc == False:
            ret_code = -2
            ret_msg = ('Failed to render template. %s' % out)
        else:
            ret_msg = out

    except:
        ret_code = -2
        ret_msg = traceback.format_exc()

    return ret_code, ret_msg
