﻿# -*- coding: UTF-8 -*-
import re
import json
import traceback


def get_tags():
    return ['2', '2.3', '2.3.3']


def run_task(runcontext):
    curtemplate = runcontext.get_template()
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)
    module = runcontext.get_module_file("shell.py")
    serverRoot = runcontext.get_extra_var('APACHE_SERVERROOT')
    serverRoot = runcontext.replace_inject_characters(serverRoot)

    runcontext.log_debug("serverRoot is: %s " % serverRoot)
    ret_code = 0
    ret_msg = ''
    errMsg = []
    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkvalue1'] = ''
    tmp_vars['checkresult1'] = 'failed'
    tmp_vars["scancommand1"] = "path=;lists=$(echo \"%s\" | awk -v RS=\"\" '{gsub(\"/\",\"\\n\");print}');for ele in $lists;do path=$path/$ele;find $path -maxdepth 0 \( -perm /g=w,o=w \) -ls 2>/dev/null;done;find / -maxdepth 0 \( -perm /g=w,o=w \) -ls 2>/dev/null;" % serverRoot
    try:
        runcontext.log_debug(tmp_vars["scancommand1"])
        runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
        arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
        runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
        runcontext.sleep()
        if arc1 != 0:
            return (-2, "Failed to invoke module: %s." % astdout1)

        resultjson1 = json.loads(astdout1)
        astdout1 = resultjson1["stdout"]

        if re.match("^$", astdout1) == None:
            errMsg.append(astdout1)

        if len(errMsg) == 0:
            tmp_vars["policyresult"] = "pass"
            tmp_vars["checkresult1"] = "pass"
            tmp_vars["checkvalue1"] = ''
        else:
            ret_code = -1
            tmp_vars["checkvalue1"] = '\n'.join(errMsg)

        rc, out = curtemplate.render(runcontext.get_template_file('r_2_3_3.j2'), **tmp_vars)

        if rc == False:
            ret_code = -2
            ret_msg = ('Failed to render template. %s' % out)
        else:
            ret_msg = out

    except:
        ret_code = -2
        ret_msg = traceback.format_exc()

    return ret_code, ret_msg
