﻿# -*- coding: UTF-8 -*-
import os
import re
import json


def get_tags():
    return ['2', '2.3', '2.3.4']


def run_task(runcontext):

    curtemplate = runcontext.get_template()
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)
    module = runcontext.get_module_file("shell.py")

    apache_home = runcontext.get_extra_var('APACHE_HOME')
    apache_bin = os.path.join(apache_home, "bin")
    apache_home = runcontext.replace_inject_characters(apache_home)
    apache_bin = runcontext.replace_inject_characters(apache_bin)

    runcontext.log_debug("apache_home,apache_bin: %s ,%s" % (apache_home, apache_bin))
    ret_code = 0
    ret_msg = ''
    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult1'] = 'failed'
    tmp_vars['checkvalue1'] = 'failed'
    tmp_vars['file_mode'] = ""
    tmp_vars["scancommand1"] = r'''stat --format="%s %s" `find %s -type f \( -perm +100  -a -perm /277 \)` 2>/dev/null''' % ("%n", "%a", apache_bin)

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
    runcontext.sleep()
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s." % astdout1)

    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]

    if re.match("^$", astdout1) != None:
        ret_code = 0
        tmp_vars['policyresult'] = 'pass'
        tmp_vars['checkresult1'] = 'pass'
        tmp_vars['checkvalue1'] = ''
    else:
        ret_code = -1
        tmp_vars['checkvalue1'] = astdout1

    rc, out = curtemplate.render(runcontext.get_template_file('r_2_3_4.j2'), **tmp_vars)

    if rc == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code, ret_msg
