﻿# -*- coding: UTF-8 -*-
import os
import json


def get_tags():
    return ['2', '2.3', '2.3.5']


def run_task(runcontext):
    logs_path = []
    serverroot = runcontext.get_extra_var('APACHE_SERVERROOT')
    conf_parse = runcontext.get_parameter('_apache_conf_parse')
    nodesErrorLog = conf_parse.find_directive(['ErrorLog'])
    runcontext.log_debug("serverroot: %s" % str(serverroot))
    if 0 != len(nodesErrorLog):
        nodeErrorLog = nodesErrorLog[-1]
        p1 = nodeErrorLog.arguments[0].strip("\"")
        if 0 != len(p1):
            if False == os.path.exists(p1):
                p1 = os.path.join(serverroot, p1)
            if os.path.exists(p1):
                p1 = os.path.normpath(p1)
                if os.path.isfile(p1):
                    tailFile1 = os.path.basename(p1)
                    if tailFile1 == "syslog":
                        pass
                    else:
                        p1 = p1.strip(tailFile1)
                        p1 = os.path.normpath(p1)
                        if p1 not in logs_path:
                            logs_path.append(p1)
                else:
                    if p1 not in logs_path:
                        logs_path.append(p1)
    nodesCustomLog = conf_parse.find_all_directive('CustomLog')
    if 0 != len(nodesCustomLog):
        nodeCustomLog = nodesCustomLog[-1]
        p2 = nodeCustomLog.arguments[0].strip("\"")
        if 0 != len(p2):
            if False == os.path.exists(p2):
                p2 = os.path.join(serverroot, p2)
            if os.path.exists(p2):
                p2 = os.path.normpath(p2)
                if os.path.isfile(p2):
                    tailFile2 = os.path.basename(p2)
                    p2 = p2.strip(tailFile2)
                    p2 = os.path.normpath(p2)
                    if p2 not in logs_path:
                        logs_path.append(p2)
                else:
                    if p2 not in logs_path:
                        logs_path.append(p2)
    if 0 == len(logs_path):
        p0 = os.path.join(serverroot, 'logs')
        if os.path.exists(p0):
            logs_path.append(p0)
    errMsg = ''
    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkresult1'] = 'failed'
    tmp_vars['file_mode'] = ''
    if 0 == len(logs_path):
        errMsg = "There is no log path!"
    else:

        ansible_params = runcontext.get_mod_params_instance()
        runcontext.set_mod_params_instance(ansible_params, '_ansible_module_name', 'file_permission')
        runcontext.set_mod_params_instance(ansible_params, 'action', runcontext.get_parameter('action'))
        runcontext.set_mod_params_instance(ansible_params, 'backupfile', os.path.join(runcontext.get_parameter('backup_path'), 'r_2_3_5.json'))
        runcontext.set_mod_params_instance(ansible_params, 'other_r', False)
        runcontext.set_mod_params_instance(ansible_params, 'other_w', False)
        runcontext.set_mod_params_instance(ansible_params, 'other_x', False)
        runcontext.set_mod_params_instance(ansible_params, 'group_r', False)
        runcontext.set_mod_params_instance(ansible_params, 'group_w', False)
        runcontext.set_mod_params_instance(ansible_params, 'group_x', False)
        module = runcontext.get_module_file('file_permission.py')
        runcontext.log_debug("logs Path is:" + ";".join(logs_path))

        for log_path in logs_path:
            runcontext.set_mod_params_instance(ansible_params, 'path', log_path)
            rc, stdout, stderr = runcontext.invoke_module(module, ansible_params)
            runcontext.log_debug_invoke_result(rc, stdout, stderr)
            runcontext.sleep()
            resultjson = json.loads(stdout)
            runcontext.log_debug_json(resultjson)

            ret_code = -2
            ret_msg = ''

            # run failed
            if 'failed' in resultjson:
                ret_code = -2
                ret_msg = resultjson['msg']
            elif 'result' in resultjson:
                result = resultjson['result']
                if False == result and 'items' in resultjson and 'mode' in resultjson['items']:
                    ret_code = -1
                    errMsg += log_path + " " + resultjson['items']['mode']

            else:
                ret_code = -2
                ret_msg = 'Result format is incorrect.'

    if 0 == len(errMsg):
        ret_code = 0
        tmp_vars['policyresult'] = 'pass'
        tmp_vars['checkresult1'] = 'pass'
        tmp_vars['file_mode'] = ''
    else:
        ret_code = -1
        tmp_vars['policyresult'] = 'failed'
        tmp_vars['checkresult1'] = 'failed'
        tmp_vars['file_mode'] = errMsg

    curtemplate = runcontext.get_template()
    rc1, out = curtemplate.render(runcontext.get_template_file('r_2_3_5.j2'), **tmp_vars)
    if False == rc1:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code, ret_msg
