# -*- coding: UTF-8 -*-
import traceback


def get_tags():
    return ['2', '2.3', '2.3.7']


def run_task(runcontext):
    rc, out = run_audit(runcontext)
    return rc, out


def run_audit(runcontext):

    ret_code = -1
    ret_msg = ''

    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkvalue1"] = ''

    conf_parse = runcontext.get_parameter('_apache_conf_parse')

    if conf_parse is None:
        ret_code = -2
        ret_msg = 'Parse apache configure file failed.'
        return ret_code, ret_msg

    try:

        tmpMsg = []
        tag = []

        #check Directory
        nodesDirectory = conf_parse.find_directive(['Directory'])
        if 0 != len(nodesDirectory):
            for nodeDirectory in nodesDirectory:
                if "/" == ' '.join(nodeDirectory.arguments):
                    checkDenyTag = False
                    checkDenyAll = False
                    checkRequire = False
                    head = '<Directory %s>' % (' '.join(nodeDirectory.arguments))
                    tmpMsg.append(head)
                    for node in nodeDirectory.get_body().get_child_nodes():
                        tmpMsg.append("    %s %s" % (node.get_name(), ' '.join(node.arguments)))
                        if node.get_name() == 'Order':
                            if 'deny,allow' in ' '.join(node.arguments).strip().lower():
                                checkDenyTag = True
                        if node.get_name() == 'Deny':
                            if 'from all' in ' '.join(node.arguments).strip().lower():
                                checkDenyAll = True
                        if node.get_name() == 'Require':
                            if 'all denied' in ' '.join(node.arguments).strip().lower():
                                checkRequire = True
                    tail = '</Directory>'
                    tmpMsg.append(tail)

                    if (checkDenyTag and checkDenyAll) or checkRequire:
                        tag.append(True)
                    else:
                        tag.append(False)

        tmp_vars["checkvalue1"] = '\n'.join(tmpMsg)

        if False not in tag:
            ret_code = 0
            tmp_vars["policyresult"] = "pass"
            tmp_vars["checkresult1"] = "pass"


        rc, out = curtemplate.render(runcontext.get_template_file('r_2_3_7.j2'), **tmp_vars)

        if rc == False:
            ret_code = -2
            ret_msg = ('Failed to render template. %s' % out)
        else:
            ret_msg = out

    except:
        ret_code = -2
        ret_msg = traceback.format_exc()

    return ret_code, ret_msg
