# -*- coding: UTF-8 -*-
import traceback


def get_tags():
    return ['2', '2.3', '2.3.8']


def run_task(runcontext):
    rc, out = run_audit(runcontext)
    return rc, out


def run_audit(runcontext):

    ret_code = 0
    ret_msg = ''

    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkvalue1"] = ''

    conf_parse = runcontext.get_parameter('_apache_conf_parse')

    if conf_parse is None:
        ret_code = -2
        ret_msg = 'Parse apache configure file failed.'
        return ret_code, ret_msg

    try:
        errMsg = []
        retCheckMsg = []
        tmpMsg = []
        nodeDirMsg = []


        #check Directory
        nodesDirectory = conf_parse.find_directive(['Directory'])
        if 0 != len(nodesDirectory):
            for nodeDirectory in nodesDirectory:
                checkDirFindOptions = False
                tmpMsg0 = []
                tmpMsg = []
                nodeDirMsg = []
                head = '<Directory %s>' % (' '.join(nodeDirectory.arguments))
                for node in nodeDirectory.get_body().get_child_nodes():
                    if node.get_name() == 'Order':
                        tmpMsg0.append("    %s %s" % (
                        node.get_name(), ' '.join(node.arguments)))
                    if node.get_name() == 'Deny':
                        tmpMsg0.append("    %s %s" % (
                        node.get_name(), ' '.join(node.arguments)))
                    if node.get_name() == 'Options':
                        checkDirFindOptions = True
                        tmpMsg0.append("    %s %s" % (node.get_name(), ' '.join(node.arguments)))
                        if 'all' in ' '.join(node.arguments).strip().lower():
                            if '-indexes' not in (''.join(node.arguments)).strip().lower():
                                checkDirFindOptions = False
                                tmpMsg.append("    %s %s" % (node.get_name(), ' '.join(node.arguments)))
                        else:
                            if 'indexes' in (''.join(node.arguments)).strip().lower() or '+indexes' in (''.join(node.arguments)).strip().lower():
                                checkDirFindOptions = False
                                tmpMsg.append("    %s %s" % (node.get_name(), ' '.join(node.arguments)))
                tail = '</Directory>'

                if checkDirFindOptions == False:
                    if 0 != len(tmpMsg):
                        nodeDirMsg.append(head)
                        nodeDirMsg.extend(tmpMsg)
                        nodeDirMsg.append(tail)
                        errMsg.extend(nodeDirMsg)
                else:
                    nodeDirMsg.append(head)
                    nodeDirMsg.extend(tmpMsg0)
                    nodeDirMsg.append(tail)
                    retCheckMsg.extend(nodeDirMsg)

        #init
        tmpMsg = []
        #check DirectoryIndex
        nodeIfModules = conf_parse.find_directive(['IfModule'])
        if 0 == len(nodeIfModules):
            errMsg.append('IfModule directive is not configured.')
        else:
            checkFind = False
            for nodeIfModule in nodeIfModules:
                if 'dir_module' in nodeIfModule.arguments:
                    tmpMsg.append('<IfModule %s>' % (' '.join(nodeIfModule.arguments)))
                    for node in nodeIfModule.get_body().get_child_nodes():
                        if node.get_name() == 'DirectoryIndex':
                            if 0 != len(node.arguments):
                                checkFind = True
                                tmpMsg.append('    %s %s' % (node.get_name(), ''.join(node.arguments)))
                                break
                            else:
                                tmpMsg.append('    %s %s' % (node.get_name(), ' '.join(node.arguments)))
                                runcontext.log_debug('<IfModule dir_module>\n    %s %s\n</IfModule>' % (node.get_name(), ' '.join(node.arguments)))
                        else:
                            tmpMsg.append('    %s %s' % (node.get_name(), ' '.join(node.arguments)))
                    tmpMsg.append('</IfModule>')
            if False == checkFind:
                errMsg.extend(tmpMsg)
            else:
                retCheckMsg.extend(tmpMsg)

        if len(errMsg) == 0:
            ret_code = 0
            tmp_vars["policyresult"] = "pass"
            tmp_vars["checkresult1"] = "pass"
            tmp_vars["checkvalue1"] = '\n'.join(retCheckMsg)
        else:
            ret_code = -1
            tmp_vars["checkvalue1"] = '\n'.join(errMsg)

        rc, out = curtemplate.render(runcontext.get_template_file('r_2_3_8.j2'), **tmp_vars)

        if rc == False:
            ret_code = -2
            ret_msg = ('Failed to render template. %s' % out)
        else:
            ret_msg = out

    except:
        ret_code = -2
        ret_msg = traceback.format_exc()

    return ret_code, ret_msg
