﻿# -*- coding: UTF-8 -*-
import re
import json
import traceback


def get_tags():
    return ['2', '2.9', '2.9.1']


def run_task(runcontext):

    curtemplate = runcontext.get_template()
    ansible_params = runcontext.get_mod_params_instance()
    module = runcontext.get_module_file("shell.py")
    httpdcfg = runcontext.get_extra_var('APACHE_CONF_FILE')
    httpdcfg = runcontext.replace_inject_characters(httpdcfg)

    runcontext.log_debug("conf_parse is: %s " % httpdcfg)
    ret_code = 0
    ret_msg = ''
    tmp_vars = {}
    tmp_vars['policyresult'] = 'failed'
    tmp_vars['checkvalue1'] = ''
    tmp_vars['checkresult1'] = 'failed'

    tmp_vars["scancommand1"] = r'''stat -c "%s %s" %s''' % ("%n", "%a", httpdcfg)
    try:
        runcontext.log_debug(tmp_vars["scancommand1"])
        runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
        arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
        runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
        runcontext.sleep()
        if arc1 != 0:
            return (-2, "Failed to invoke module: %s." % astdout1)

        resultjson1 = json.loads(astdout1)
        astdout1 = resultjson1["stdout"]
        tmp_vars["checkvalue1"] = astdout1

        if re.search(r"\s([0246][04][04]|0)$", astdout1):
            tmp_vars["checkresult1"] = "pass"
            tmp_vars["policyresult"] = "pass"
        else:
            ret_code = -1
            tmp_vars["checkresult1"] = "failed"
            tmp_vars["policyresult"] = "failed"


        rc, out = curtemplate.render(runcontext.get_template_file('r_2_9_1.j2'), **tmp_vars)

        if rc == False:
            ret_code = -2
            ret_msg = ('Failed to render template. %s' % out)
        else:
            ret_msg = out

    except:
        ret_code = -2
        ret_msg = traceback.format_exc()

    return ret_code, ret_msg
