﻿# -*- coding: UTF-8 -*-
import traceback
import re

def get_tags():
    return ['2', '2.9', '2.9.3']


def run_task(runcontext):
    rc, out = run_audit(runcontext)
    return rc, out


def run_audit(runcontext):

    ret_code = 0
    ret_msg = ''

    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkvalue1"] = ''

    conf_parse = runcontext.get_parameter('_apache_conf_parse')

    if conf_parse is None:
        ret_code = -2
        ret_msg = 'Parse apache configure file failed.'
        return ret_code, ret_msg

    try:
        errMsg = []
        corrMsg = []

        #get all ServerSignature  nodes
        nodeAcceptFilter = conf_parse.find_directive(['AcceptFilter'])
        if len(nodeAcceptFilter) == 0:
            corrMsg.append("AcceptFilter http data")
        else:
            node = re.search(r"AcceptFilter \s*http \s*(.+)", nodeAcceptFilter, re.I)
            if node:
                data = node.group(1)
                if "data" != data:
                    errMsg.append(node.group(0))
                else:
                    corrMsg.append("AcceptFilter http data")
            else:
                corrMsg.append("AcceptFilter http data")


        if len(errMsg) == 0:
            ret_code = 0
            tmp_vars["policyresult"] = "pass"
            tmp_vars["checkresult1"] = "pass"
            tmp_vars["checkvalue1"] = '\n'.join(corrMsg)
        else:
            ret_code = -1
            tmp_vars["checkvalue1"] = '\n'.join(errMsg)

        rc, out = curtemplate.render(runcontext.get_template_file('r_2_9_3.j2'), **tmp_vars)

        if rc == False:
            ret_code = -2
            ret_msg = ('Failed to render template. %s' % out)
        else:
            ret_msg = out

    except:
        ret_code = -2
        ret_msg = traceback.format_exc()

    return ret_code, ret_msg
