# -*- coding: UTF-8 -*-
import os
import traceback


def get_tags():
    return ['2', '2.1', '2.1.4']


def run_task(runcontext):
    rc, out = run_audit(runcontext)
    return rc, out


def run_audit(runcontext):

    ret_code = 0
    ret_msg = ''

    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkvalue1"] = ''

    conf_parse = runcontext.get_parameter('_apache_conf_parse')

    if conf_parse is None:
        ret_code = -2
        ret_msg = 'Parse apache configure file failed.'
        return ret_code, ret_msg

    try:
        errMsg = []

        # check Alias icons
        nodeAliasArguments = []
        nodeAlias = conf_parse.find_all_directive('Alias')

        if 0 == len(nodeAlias):
            pass
        else:
            for nodea in nodeAlias:
                if '/icons/' in [str(x).strip("\"") for x in nodea.arguments]:
                    nodea.arguments.remove('/icons/')
                    nodeAliasArguments.append((''.join(nodea.arguments).strip('\"')))

            nodeAliasArguments = list(set(nodeAliasArguments))

            if 0 == len(nodeAliasArguments):
                pass
            else:
                # if Alias /icons/ "/var/www/icons/" exist, check directory icons
                nodeDirectorys = conf_parse.find_directive(['Directory'])
                if 0 == len(nodeDirectorys):
                    pass
                else:
                    nodeDirArguments = []
                    for noded in nodeDirectorys:
                        if '/icons' in (' '.join(noded.arguments)).strip('\"'):
                            nodeDirArguments.append((''.join(noded.arguments).strip('\"')))
                    nodeDirArguments = list(set(nodeDirArguments))  #Deduplication

                    # check directory icons logic
                    if 0 != len(nodeDirArguments):
                        if len(nodeAliasArguments) != len(nodeDirArguments):
                            errMsg.append('Alias /icons/ \"%s\"\n<Directory \"%s\">\n    ...\n</Directory>' % (','.join(nodeAliasArguments), ','.join(nodeDirArguments)))
                        else:
                            auxResult = []
                            for no in nodeAliasArguments:
                                if no.rstrip(os.sep) in nodeDirArguments:
                                    auxResult.append(False)
                                    continue
                                if no.rstrip(os.sep).rstrip('/') in nodeDirArguments:
                                    nodeDirArguments.remove(no.rstrip(os.sep).rstrip('/'))
                                nodeAliasArguments.remove(no)
                                auxResult.append(True)
                            if False in auxResult:
                                errMsg.append('Alias /icons/ \"%s\"\n<Directory  \"%s\">\n    ...\n</Directory>' % ('/'.join(nodeAliasArguments), '/'.join(nodeDirArguments)))

        if len(errMsg) == 0:
            tmp_vars["policyresult"] = "pass"
            tmp_vars["checkresult1"] = "pass"
            tmp_vars["checkvalue1"] = ''
        else:
            ret_code = -1
            tmp_vars["checkvalue1"] = '\n'.join(errMsg)

        rc, out = curtemplate.render(runcontext.get_template_file('r_2_1_4.j2'), **tmp_vars)

        if rc == False:
            ret_code = -2
            ret_msg = ('Failed to render template. %s' % out)
        else:
            ret_msg = out

    except:
        ret_code = -2
        ret_msg = traceback.format_exc()

    return ret_code, ret_msg
