# -*- coding: UTF-8 -*-
import os

def get_tags():
    return ['2', '2.4', '2.4.9']


def run_task(runcontext):
    rc, out = run_audit(runcontext)
    return rc, out


def run_audit(runcontext):

    ret_code = 0
    ret_msg = ''

    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkvalue1"] = ''
    apche_scriptalias = runcontext.get_extra_var('APACHE_SCRIPTALIAS')
    runcontext.log_debug('apche_scriptalias:%s' % apche_scriptalias)
    errMsg = []
    if 0 == len(apche_scriptalias):
        pass
    else:
        for cgiPaths in apche_scriptalias:
            cgiPath = os.path.normpath(cgiPaths[1])
            cgiPathList = []
            cgiPathList.append(cgiPath + os.sep + 'printenv')
            cgiPathList.append(cgiPath + os.sep + 'test-cgi')
            for cgiPathtemp in cgiPathList:
                if os.path.exists(cgiPathtemp):
                    errMsg.append('%s is exist' % cgiPathtemp)
                    runcontext.log_debug('%s is exist' % cgiPathtemp)

    if 0 == len(errMsg):
        ret_code = 0
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["checkvalue1"] = ''
    else:
        ret_code = -1
        tmp_vars["checkvalue1"] = '\n'.join(errMsg)

    rc, out = curtemplate.render(runcontext.get_template_file('r_2_4_9.j2'), **tmp_vars)

    if rc == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code, ret_msg
